//
//  CYConstManager.h
//  Lighting
//
//  Created by 曹云霄 on 2016/10/17.
//  Copyright © 2016年 上海勾芒科技有限公司. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <UIKit/UIKit.h>
#import "MBProgressHUD.h"
#import "MJRefresh.h"
#import "MMDrawerController.h"
#import "RightViewController.h"
#import "IQKeyboardManager.h"
#import "AFNetworking.h"
#import "NetworkRequestClassManager.h"
#import "NSArray+Objectwithindex.h"
#import "ShoppingViewController.h"
#import "ClientViewController.h"
#import "Masonry.h"
#import "PopoverViewController.h"
#import "opple_objc_json_client.h"
#import "JSONModel.h"
#import "Shoppersmanager.h"
#import "UIImageView+WebCache.h"
#import "Customermanager.h"
#import "AppDelegate.h"
#import "BaseViewController.h"
#import "MjRefreshHeaderCustom.h"
#import "UIScrollView+EmptyDataSet.h"
#import "UINavigationController+FDFullscreenPopGesture.h"
#import "XLPlainFlowLayout.h"
#import "MDScratchImageView.h"
#import "WYPopoverController.h"
#import "CustomBorderLabel.h"
#import "PNCircleChart.h"
#import "CustomStudyEntity.h"
#import "XBLoadingView.h"
#import "CustomTOStudyTopicOptionEntity.h"
#import "CountDownLabel.h"
#import "CustomTOStudyTopicEntity.h"
#import "CustomTOPassLevelTopicEntity.h"
#import "CustomTOPassLevelTopicOptionEntity.h"
#import "CustomImageBackView.h"
#import "CustomTOForumTopicEntity.h"
#import "CustomTOForumReplyEntity.h"
#import "PNCircleChart.h"
#import "NSString+Category.h"
#import "CustomTOAfficheEntity.h"
#import "ICRPlaceholderTextView.h"
#import "YXAlertController.h"
#import "WZLBadgeImport.h"
#import <UMSocialCore/UMSocialCore.h>
#import "YXKitHeader.h"
#import "IQUIView+Hierarchy.h"
#import "BasePullTableViewController.h"
#import "BasePullCollectionViewController.h"
#import "UIViewController+StoryBoard.h"
// 引入JPush功能所需头文件
#import "JPUSHService.h"
// iOS10注册APNs所需头文件
#ifdef NSFoundationVersionNumber_iOS_9_x_Max
#import <UserNotifications/UserNotifications.h>
#endif


/**
 闯关结果
 
 - NotThrough: 未通过
 - Through:    已通过
 - Audit:      待审核
 */
typedef NS_ENUM(NSInteger,RESULT_STATE){
    NotThrough = 0,
    Through,
    Audit
};


/**
 点赞或评论
 
 - Comment:   评论
 - Praise:    点赞
 */
typedef NS_ENUM(NSInteger,COMMENT_PRAISE) {
    Comment = 0,
    Praise
};



/*****************************************接口地址*****************************************/

#if Lighting

/**
 *  服务器开发地址
 */
#define SERVERREQUESTURL(URL)  [NSString stringWithFormat:@"http://192.168.1.176:8082/opple-web/app%@",URL]


#elif LightingDev

/**
 *  服务器测试地址
 */
#define SERVERREQUESTURL(URL)  [NSString stringWithFormat:@"http://dg-dev.opple.com/opple-web/app%@",URL]


#elif LightingDis

/**
 *  服务器正式地址
 */
#define SERVERREQUESTURL(URL)  [NSString stringWithFormat:@"http://dg.opple.com/opple-web/app%@",URL]


#endif


/**
 *  猪八戒3D
 */
extern NSString *const BAJIE3D;

/**
 *  登陆
 */
extern NSString *const LOGIN;

/**
 *  门店地址
 */
extern NSString *const STOREADDRESS;

/**
 *  发送验证码
 */
extern NSString *const SENDSMS;

/**
 *  绑定银行卡
 */
extern NSString *const SENDSMSBANK;

/**
 *  重置密码
 */
extern NSString *const RESETPASSWORD;

/**
 *  新增地址
 */
extern NSString *const ADDADDRESS;

/**
 *  更改地址
 */
extern NSString *const CHANGEADDRESS;

/**
 *  删除地址
 */
extern NSString *const REMOVEADDRESS;

/**
 *  场景筛选
 */
extern NSString *const SCENESCREENING;

/**
 *  热门搜索
 */
extern NSString *const HOTSEARCH;

/**
 *  场景列表
 */
extern NSString *const SCENELIST;

/**
 *  经营者二维码
 */
extern NSString *const QRCODE;

/**
 *  确认支付
 */
extern NSString *const CONFIRMPAY;

/**
 *  获取购物袋商品
 */
extern NSString *const SHOPPINGBAG;
/**
 *  获取欧管家导购
 */
extern NSString *const GETSTEWARD;
/**
 *  删除购物袋
 */
extern NSString *const REMOVESHOPPINGBAG;

/**
 *  更改购物车商品数量、价格
 */
extern NSString *const CHANGESHOPPINGBAGNUMBERPRICE;

/**
 *  添加到购物车
 */
extern NSString *const ADDSHOPPINGBAG;

/**
 *  查询购物车数量
 */
extern NSString *const QUERYSHOPPINGBAGNUMBER;

/**
 *  查询所有订单
 */
extern NSString *const QUERYORDER;

/**
 *  撤销订单
 */
extern NSString *const RESETORDER;

/**
 *  分享商品
 */
extern NSString *const SHARE;

/**
 *  分享订单
 */
extern NSString *const SHAREORDERBILL;

/**
 *  产品筛选
 */
extern NSString *const PRODUCTSCREENING;

/**
 *  产品列表
 */
extern NSString *const PRODUCTLIST;

/**
 *  条形码搜索
 */
extern NSString *const BARCODESEARCH;

/**
 *  获取导购关联客户
 */
extern NSString *const GETshoppersCONSUMER;

/**
 *  修改密码
 */
extern NSString *const MODIFYPASSWORD;

/**
 *  获取门店设计师列表
 */
extern NSString *const GETINVITER;

/**
 *  订单详情
 */
extern NSString *const ORDERDETAILS;

/**
 *  PDF路径
 */
extern NSString *const DOWNLOADPDF;

/**
 *  收货地址
 */
extern NSString *const SHIPPINGADDRESS;

/**
 *  生成订单
 */
extern NSString *const CREATEORDER;

/**
 *  商品详情
 */
extern NSString *const GOODSDETAILS;

/**
 *  导购返利
 */
extern NSString *const shoppersCOMMISSION;

/**
 *  上传文件
 */
extern NSString *const UPLOADHEADER;

/**
 *  修改导购个人信息
 */
extern NSString *const MODITYshoppersINFORMATION;

/**
 *  注销登录
 */
extern NSString *const CANCELLOGIN;

/**
 *  新增客户
 */
extern NSString *const ADDCONSUMER;

/**
 *  写入访问时间
 */
extern NSString *const SAVEVISITEDTIME;

/**
 *  获取版本升级信息
 */
extern NSString *const VERSION;

/**
 *  查询返利信息
 */
extern NSString *const REBATE;

//** 提现 */
extern NSString *const WITHDRAWAL;

/**
 *  收支明细
 */
extern NSString *const PAYMENTS;

/**
 *  提现进度
 */
extern NSString *const WITHDRAWALPROGRESS;

/**
 *  提现进度详情
 */
extern NSString *const WITHDRAWALPROGRESSDETAILS;

/**
 *  查询促销信息
 */
extern NSString *const PROMOTIONAL;

/**
 *  查询历史促销信息
 */
extern NSString *const OLDPROMOTIONAL;

/**
 *  查询我的卡劵信息
 */
extern NSString *const CARDINFORMATION;

/**
 * 发放JDEka
 */
extern NSString *const JDECARD;

/**
 *  激活京东E卡
 */
extern NSString *const ACTIVIATIONJDECARD;

/**
 *  领取京东E卡
 */
extern NSString *const  RECEIVEJDECARD;

/**
 *  查询所有京东E卡
 */
extern NSString *const QUERYALLJDECARD;

/**
 *  微信卡劵
 */
extern NSString *const WeChatCard;

/**
 *  使用京东E卡
 */
extern NSString *const  USEJDECARD;

/**
 *  抽奖
 */
extern NSString *const DRAW;

/**
 *  拼接订单详情URL(打印/预览)
 */
extern NSString *const ORDERDETAILSURL;

/**
 *  抽奖结果查询
 */
extern NSString *const LOTTERYED;

/**
 *  使用微信卡劵
 */
extern NSString *const USEWECHATCARD;

/**
 *  查询积分
 */
extern NSString *const INTEGRALQUERY;

/**
 *  奖品列表
 */
extern NSString *const PRIZELIST;

/**
 *  所有的兑奖记录
 */
extern NSString *const ALLEXCHANGERECORD;

/**
 *  是否有兑奖资格
 */
extern NSString *const EXCHANGEQUALIFICATION;

/**
 *  保存兑奖单
 */
extern NSString *const SAVEPRIZEBILL;

/**
 *  兑奖单详情
 */
extern NSString *const PRIZEBILLDETAILS;

/**
 *  公告列表
 */
extern NSString *const AFFICHELIST;

/**
 *  公告详情
 */
extern NSString *const AFFICHEdETAILS;

/**
 *  学习类型
 */
extern NSString *const STUDYTYPES;

/**
 *  论坛讨论项分类第二层
 */
extern NSString *const FORUMCATEGORYS;
/**
 *  论坛讨类型第一层
 */
extern NSString *const FORUMTYPS;

/**
 *  学习项详情
 */
extern NSString *const STUDYITEMDETAIL;

/**
 *  学习列表
 */
extern NSString *const STUDYLIST;

/**
 *  闯关信息
 */
extern NSString *const THROUGHLIST;

/**
 *  提交考核结果
 */
extern NSString *const SUBMITANSWER;

/**
 *  获取相应分数对应的积分
 */
extern NSString *const GETINTEGRAL;

/**
 *  获取闯关详情
 */
extern NSString *const GETPASSLEVELDETAILS;

/**
 *  提交闯关答案
 */
extern NSString *const SUBMITEMIGRATEDANSWER;

/**
 *  查询论坛列表
 */
extern NSString *const QUERTFORUMLIST;

/**
 *  发布帖子
 */
extern NSString *const SUBMITTOPIC;

/**
 *  回复帖子
 */
extern NSString *const REPLYPOST;

/**
 *  最佳回复、取消最佳回复
 */
extern NSString *const BASEREPLY;

/**
 *  点赞、取消点赞
 */
extern NSString *const PRAISE;

/**
 *  删除帖子
 */
extern NSString *const DELETEPOST;

/**
 *  帖子详情
 */
extern NSString *const POSTDETAIL;

/**
 *  公告已读
 */
extern NSString *const READANNOUNCEMENT;

/**
 *  验证银行卡信息
 */
extern NSString *const VALIDATION;

/**
 *  绑定银行卡
 */
extern NSString *const BINDING;

/**
 *  解除绑定银行卡
 */
extern NSString *const UNBINDING;

/**
 *  学习完成
 */
extern NSString *const FINISHSTUDY;

/**
 *  附件播放时间
 */
extern NSString *const ATTACHMENTPLAYTIME;

/**
 *  消息已读
 */
extern NSString *const MESSAGE_READ;

/**
 *  首页数据
 */
extern NSString *const HOME_DATA;

/**
 *  闯关结果
 */
extern NSString *const PASSLEVERESULT;

/**
 *  验证经销商ID是否正确
 */
extern NSString *const RESELLER;

/**
 *  保存经销商ID
 */
extern NSString *const SAVERESELLER;
/**
 *  首页轮播图速度
 */
extern NSString *const BANNERS_SPEED;

/**
 *  时间轴主题
 */
extern NSString *const GETTIMELINE;
/**
 *  综合讨论区
 */
extern NSString *const DEFAULTFORUM_CATEGORY;
/**
 *  查询红包
 */
extern NSString *const QUERY_REDPACKAGE;
/**
 *  上传红包小票路径
 */
extern NSString *const READPACKETPATH;

/**
 *  保存门店地区
 */
extern NSString *const ADDRESS;

/**
 *  读帖
 */
extern NSString *const READTOPIC;
/*****************************************接口地址*****************************************/


/**
 *  通知已上传小票
 */
extern NSString *const UPLOAD_COMPLETE;

/**
 *  通知已查看京东卡密码
 */
extern NSString *const VIEWPASSWORD;

/**
 *  京东卡状态<发放>
 */
extern NSString *const DISPENSED;

/**
 *  京东卡状态<激活>
 */
extern NSString *const ACTIVED;

/**
 *  京东卡状态<查看>
 */
extern NSString *const USED;

/**
 *  京东卡状态<审批中>
 */
extern NSString *const CHECK;

/**
 *  更新购物车商品
 */
extern NSString *const SHOPPINGCARGOODS;


/**
 *  打开体验中心
 */
extern NSString *const OPENFOLLOWHEARTVC;

/**
 *  微信卡劵
 */
extern NSString *const WXCardAction;

/**
 *  京东E卡
 */
extern NSString *const JDECardAction;

/**
 *  导购
 */
extern NSString *const GUIDE;

/**
 *  消费者
 */
extern NSString *const CONSUMER;

/**
 *  折扣金额
 */
extern NSString *const deductionAction;

/**
 *  现金红包
 */
extern NSString *const redPackageAction;

/**
 *  大转盘红包
 */
extern NSString *const dzpRedPackage;

/**
 *  赠送商品
 */
extern NSString *const goodsAction;

/**
 *  转盘抽奖
 */
extern NSString *const lotteryAction;

/**
 *  已抽奖未使用
 */
extern NSString *const ACCOMPLISHED;

/**
 未抽奖
 */
extern NSString *const INITIAL;

/**
 *  刷新购物车
 */
extern NSString *const REFRESHSHOPPINGCAR;

/**
 *  更改用户名
 */
extern NSString *const CHANGECUSTOMERNAME;

/**
 *  更改导购名
 */
extern NSString *const CHANGEshoppersNAME;

/**
 *  打开3D体验中心
 */
extern NSString *const OPENFOLLOWHEART3DVC;

/**
 *  未读公告
 */
extern NSString *const NOTREADANNOUNCEMENT;

/**
 *  学习完成
 */
extern NSString *const STUDYFINISH;

/**
 *  考核通过
 */
extern NSString *const INSPECTIONTHROUGH;

/**
 *  闯关通过
 */
extern NSString *const RECRUITTHROUGH;

/**
 *  返利
 */
extern NSString *const COMMISSION;
/**
 *  红包
 */
extern NSString *const REDPACKAGE;
/**
 *  欧普问问
 */
extern NSString *const OPPLE_ASK;

/**
 *  消息列表
 */
extern NSString *const MESSAGELIST;
/**
 *  消息
 */
extern NSString *const MESSAGE_COUNT;
/**
 *  通知
 */
extern NSString *const NSNOTIFICATION_MESSAGE;

/**
 *  分享帖子
 */
extern NSString *const SHAREINVITATION;


/**
 *  登陆超时通知
 */
extern NSString *const LOGINTIMEOUT;

/**
 *  更新版本通知
 */
extern NSString *const UPLOADVERSION;

/**
 *  网络断开
 */
extern NSString *const NETWORK;

/**
 *  搜索框输入通知
 */
extern NSString *const SEARCHSTRING;

/**
 *  搜索框返回根视图
 */
extern NSString *const POPROOTCONTROLLER;

/**
 *  储存本地的搜索历史文件名
 */
extern NSString *const SEARCHHISTORY;

/**
 *  保存用户名key
 */
extern NSString *const USERNAME;

/**
 *  保存密码key
 */
extern NSString *const PASSWORD;

/**
 *  网络请求返回个数
 */
extern NSInteger const KROWS;

/**
 保存账号密码serviceName
 */
extern NSString *const SERVICENAME;

/**
 保存账号key
 */
extern NSString *const SAVEACCOUNT;

/**
 保存密码key
 */
extern NSString *const SAVEPASSWORD;
/**
 时间轴动画
 */
extern NSString *const ANIMATION;
/**
 刷新综合讨论区
 */
extern NSString *const REFRESH_FROUMLIST;
/**
 修改导购名称
 */
extern NSString *const CHANGEGUIDENAME;
/**
 设置当前客户
 */
extern NSString *const SETUPCURRENTCUSTOMER;
/**
 退出当前客户
 */
extern NSString *const EMPTYCUSTOMERNAME;

